// device and clock...
Device = 18F2550
Clock = 48
   
// 20Mhz crystal, 48Mhz internal (FS USB)
Config
   PLLDIV = 5,
   CPUDIV = OSC1_PLL2,
   USBDIV = 2,
   FOSC = HSPLL_HS,
   VREGEN = ON

// this is the programs descriptor, generated by EasyHID - you
// can find it in the same folder as this program...
#option USB_DESCRIPTOR = "iHIDDesc.bas"

// import the HID and other used modules...
Include "usbhid.bas"
Include "USART.bas"
Include "convert.bas"

Dim BufferOut(32) As Byte Absolute TXReportRAM
Dim BufferIn(32) As Byte Absolute RXReportRAM
Dim i As Byte

// setup USART
SetBaudrate(br115200)

// main program loop
While True
    // connect to USB...
    Repeat
    Until Attached
    
    While Attached
        // fill report buffer
        For i = 0 To 31   
            BufferOut(i) = i
        Next
        
        // send report
        WriteArray(BufferOut,32)
        
        // check for new report
        If HID.DataAvailable Then
          ReadReport
          // send each byte of the report via USART
          For i = 0 To 31
            HID.DisableISR      // disable USB interrupt handling for timing critical events
                                //  note: if more than 1mS elapses then USB will be disconnected.
                                //        call Service() to refresh USB connection before that happens.
            USART.Write(DecToStr(BufferIn(i)),13,10)
            HID.EnableISR       // enable USB interrupt handling
          Next
        EndIf       
        
        DelayMS(1000)
    Wend
Wend
